#ifndef STRUCTURES_H_INCLUDED
#define STRUCTURES_H_INCLUDED

#define TAILLE_MAX_CARTE 256
#define TAILLE_NOMS 16
/* definition des structures ncessaires : case, classe, etc */

typedef char* type_nom;

typedef enum {faux, vrai} boolean;

typedef struct {
    type_nom nom;
    boolean franchissable;
    unsigned short int PD_requis;
} type_terrain;


typedef struct {
    unsigned short int coord_x;
    unsigned short int coord_y;
    type_terrain *terrain;
    boolean occupee;
    boolean surbrillance;
} Case;

typedef Case carte[TAILLE_MAX_CARTE];

typedef struct {
    type_nom nom;
    unsigned short int degats_directs;
    unsigned short int degats_permanents;
    boolean paralysie;
} attaque;

typedef struct {
    type_nom nom;
    attaque* attaques;
    unsigned short int points_deplacement_max;
    unsigned short int PV_max;
    unsigned short int mana_max;
} classe;

typedef struct {
    type_nom nom;
    classe classe;
    unsigned short int points_deplacement;
    unsigned short int PV;
    unsigned short int mana;
    boolean paralyse;
    Case *position;
} personnage;


typedef struct competence{
    unsigned short int id;
    type_nom nom;
    unsigned short int etage;
    struct competence *parent;
    struct competence *enfant_gauche;
    struct competence *enfant_droit;
    struct effet_competence *effet;
    boolean connu;
}competence;

typedef struct effet_competence{
    unsigned short int id;
    type_nom nom;
    /* effets  dfinir */

}effet_competence;

#endif
